import sys
sys.path.insert(0, '../lib')
import dtox.format, dtox.grammar, dtox.parser

from cStringIO import StringIO

from xml.sax import make_parser, SAXParseException
from xml.sax.handler import feature_namespaces

FMT_STRING = r"""<?xml version="1.0"?>
<ax:format xmlns:ax="http://hetland.org/atox">

  <doc>
    <ax:fill/>
    <ax:rep>
      <ax:alt>
        <ax:match name="c"/>
        <ax:match name="q"/>
        <ax:match name="e"/>
      </ax:alt>
      <ax:fill/>
    </ax:rep>
  </doc>

  <ax:def name="e">
    <e>
      <ax:del>\*</ax:del>
      <ax:fill/>
      <ax:rep>
        <ax:alt>
          <ax:match name="c"/>
          <ax:match name="q"/>
        </ax:alt>
        <ax:fill/>
      </ax:rep>
      <ax:del>\*</ax:del>
    </e>
  </ax:def>

  <ax:def name="q">
    <q>
      <ax:del>\"</ax:del>
      <ax:fill/>
      <ax:rep>
        <ax:alt>
          <ax:match name="c"/>
          <ax:match name="e"/>
        </ax:alt>
        <ax:fill/>
      </ax:rep>
      <ax:del>\"</ax:del>
    </q>
  </ax:def>

  <ax:def name="c">
    <c>
      <ax:del>'</ax:del>
      <ax:fill/>
      <ax:del>'</ax:del>
    </c>
  </ax:def>

</ax:format>"""

g = dtox.grammar.Grammar()
b = dtox.format.Builder(g)

p = make_parser()
p.setContentHandler(b)
p.setFeature(feature_namespaces, True)

p.parse(StringIO(FMT_STRING))

fcode = dtox.parser.flexCode(g, 'myparser')
bcode = dtox.parser.bisonCode(g, 'myparser')

dtox.parser.compile(fcode, bcode, 'myparser') # Ends up in current directory
